package jp.gihyo.mitoma.careTimerV01.activity.model;
import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareDAO implements CareDAOInterface{
	private SQLiteDatabase db;
    private final static String DB_TABLE = "carePlan";
    public CareDAO(Context context){
    	this.db=DbConnect.getInstance(context)
    			.getWritableDatabase();
    }
    public CareDTO selectOne(String memNo,String date,String planNo){
    	CareDTO dto=new CareDTO();
     	String[] select={"memNo","memName","date",
    			"careCode","careName","planNo","predTime","implTime","result",
    			"helperCode","helperName"};
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	String groupBy=null;
    	String having=null;
    	String orderBy="predTime";
        Cursor cursol=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
       if(cursol.moveToFirst()){
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setCareCode(cursol.getString(3));
	        dto.setCareName(cursol.getString(4));
	        dto.setPlanNo(cursol.getString(5));
	        dto.setPredTime(cursol.getString(6));
	        dto.setImplTime(cursol.getString(7));
	        dto.setResult(cursol.getString(8));
	        dto.setHelperCode(cursol.getString(9));
	        dto.setHelperName(cursol.getString(10));
	    }
        cursol.close();
        return dto;
    }
    public ArrayList<CareDTO> selectSet(String memNo,String date){
    	CareDTO dto;
    	ArrayList<CareDTO> careList=new ArrayList<CareDTO>();
    	String[] select={"memNo","memName","date",
    			"careCode","careName","planNo","predTime","implTime","result",
    			"helperCode","helperName"};
    	String where="memNo=? AND date=?";
    	String[] whereArgs=new String[2];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	String groupBy=null;
    	String having=null;
    	String orderBy="predTime";
        Cursor cursol=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
       while(cursol.moveToNext()){
    	   dto=new CareDTO();
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setCareCode(cursol.getString(3));
	        dto.setCareName(cursol.getString(4));
	        dto.setPlanNo(cursol.getString(5));
	        dto.setPredTime(cursol.getString(6));
	        dto.setImplTime(cursol.getString(7));
	        dto.setResult(cursol.getString(8));
	        dto.setHelperCode(cursol.getString(9));
	        dto.setHelperName(cursol.getString(10));
	        careList.add(dto);
        }
        cursol.close();
        return careList;
    }
    public int deleteOne(String memNo,String date,String planNo){ 
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	return db.delete(DB_TABLE,where,whereArgs);
    }
    public int deleteSet(String memNo,String date){ 
    	String where="memNo=? AND date=?";
    	String[] whereArgs=new String[2];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	return db.delete(DB_TABLE,where,whereArgs);
    }    
    public int deleteAll(){    	
    	return db.delete(DB_TABLE,null,null);
    }
    public int insertOne(CareDTO dto){
    	ContentValues values=new ContentValues();    	
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("careCode",dto.getCareCode());
        values.put("careName",dto.getCareName());        
        values.put("planNo",dto.getPlanNo());
        values.put("predTime",dto.getPredTime());
        values.put("implTime",dto.getImplTime());
        values.put("result",dto.getResult());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
        return (int)db.insert(DB_TABLE,null,values);
    }
    public int insertSet(ArrayList<CareDTO> careList){
    	int count=0;
    	for(int i=0;i<careList.size();i++){
    		this.insertOne(careList.get(i));
    		count++;
    	}
    	return count;
    }
    //s̍XV
    public int updateOne(CareDTO dto){
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=dto.getMemNo();
    	whereArgs[1]=dto.getDate();
    	whereArgs[2]=dto.getPlanNo();
        ContentValues values=new ContentValues();
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("careCode",dto.getCareCode());
        values.put("careName",dto.getCareName());        
        values.put("planNo",dto.getPlanNo());
        values.put("predTime",dto.getPredTime());
        values.put("implTime",dto.getImplTime());
        values.put("result",dto.getResult());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
        return db.update(DB_TABLE,values,where,whereArgs);
    }
    public int updateSet(ArrayList<CareDTO> careList){
    	int count=0;
    	for(int i=0;i<careList.size();i++){
    		this.updateOne(careList.get(i));
    		count++;
    	}
    	return count;
    }
}
