package jp.gihyo.mitoma.careTimer.service;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;

import jp.gihyo.mitoma.careTimer.activity.model.CareProvDAO;
import jp.gihyo.mitoma.careTimer.activity.model.CareDTO;
import jp.gihyo.mitoma.careTimer.R;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;
import android.text.format.DateFormat;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareTimerTask extends TimerTask implements OnInitListener{
	private static final String LOGC = "CareTimerTask";
    private CareProvDAO careDAO;
    private NotificationManager notifManager;
    private Context context;
    private TextToSpeech tts;
    private boolean ttsAvailable;
    public CareTimerTask(Context context){
    	this.context=context;
    	this.careDAO=new CareProvDAO(context);
    	this.notifManager=(NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);
    	this.tts=new TextToSpeech(this.context,this);
    }
	public void run() {
		Calendar now = Calendar.getInstance();
	    String today=(String)DateFormat.format("yyyy/MM/dd",now);
	    String currentTime=(String) DateFormat.format("kk:mm",now);
	    String where="date='"+today+"' AND predTime <='"+currentTime
	    		+"' AND implTime=''";
	    ArrayList<CareDTO> dtoArray=careDAO.selectAny(where);
	    CareDTO dto;
	    while(true){
	    	notifManager.cancel(0);
	    	if(dtoArray.isEmpty())break;
	    	dto=dtoArray.get(0);
	  		Notification notif=new Notification();
	  		notif.icon=R.drawable.clock_red;
	  		notif.defaults |=Notification.DEFAULT_SOUND;
	  		notif.flags |=Notification.FLAG_AUTO_CANCEL;
	  		notif.when=System.currentTimeMillis();
	  		Intent intent=new Intent();
	  		intent.setAction("jp.gihyo.mitoma.careTimer.MAIN_VIEW");
	  		intent.putExtra("memNo", dto.getMemNo());
	  		PendingIntent pi = 
		            PendingIntent.getActivity(context, 0, intent, 0);
	  		String summary=
	  				dto.getMemNo()+" "+dto.getMemName()+""
	  						+dto.getCareName()+"̎ԂłB";
	  		notif.setLatestEventInfo(context, "\",summary, pi);
	  		if(this.ttsAvailable){
	    		this.tts.speak(dto.getMemName()+" @",TextToSpeech.QUEUE_ADD, null);
	    		this.tts.speak(dto.getCareName()+"̎Ԃł",TextToSpeech.QUEUE_ADD, null);
	    	}
	  		notifManager.notify(0, notif);	  		
	  		break;
	    }
	}
	public void notifCancel(){
		this.notifManager.cancel(0);
		this.tts.shutdown();
	}
	public void onInit(int status) {
		if(status==TextToSpeech.SUCCESS){
				this.ttsAvailable=true;
		}else{			
		}	
	}
}
