package jp.gihyo.mitoma.careWalkV01.model;
import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class WalkDAO implements WalkDAOInterface{
	private SQLiteDatabase db;
    private final static String DB_TABLE = "walking";
    public WalkDAO(Context context){
    	this.db=DbConnect.getInstance(context)
    			.getWritableDatabase();
    }
    public WalkDTO selectOne(String memNo,String date,String planNo){
    	WalkDTO dto=new WalkDTO();
     	String[] select={"memNo","memName","date","planNo",
    			"time","latitude","longitude","helperCode","helperName"};
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	String groupBy=null;
    	String having=null;
    	String orderBy="time";
        Cursor cursol=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
       if(cursol.moveToFirst()){
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setPlanNo(cursol.getString(3));
	        dto.setTime(cursol.getString(4));
	        dto.setLatitude(cursol.getString(5));
	        dto.setLongitude(cursol.getString(6));
	        dto.setHelperCode(cursol.getString(7));
	        dto.setHelperName(cursol.getString(8));
	    }
        cursol.close();
        return dto;
    }
    public ArrayList<WalkDTO> selectSet(String memNo,String date,String planNo){
    	WalkDTO dto;
    	ArrayList<WalkDTO> careList=new ArrayList<WalkDTO>();
    	String[] select={"memNo","memName","date","planNo",
    			"time","latitude","longitude","helperCode","helperName"};
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	String groupBy=null;
    	String having=null;
    	String orderBy="time";
        Cursor cursol=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
       while(cursol.moveToNext()){
    	   dto=new WalkDTO();
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setPlanNo(cursol.getString(3));
	        dto.setTime(cursol.getString(4));
	        dto.setLatitude(cursol.getString(5));
	        dto.setLongitude(cursol.getString(6));
	        dto.setHelperCode(cursol.getString(7));
	        dto.setHelperName(cursol.getString(8));
	       careList.add(dto);
        }
        cursol.close();
        return careList;
    }
    public ArrayList<WalkDTO> selectAny(String where){
    	WalkDTO dto;
    	ArrayList<WalkDTO> careList=new ArrayList<WalkDTO>();
    	String[] select={"memNo","memName","date","planNo",
    			"time","latitude","longitude","helperCode","helperName"};
    	String[] whereArgs=null;
    	String groupBy=null;
    	String having=null;
    	String orderBy="time";
        Cursor cursol=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
       while(cursol.moveToNext()){
    	   dto=new WalkDTO();
    	    dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setPlanNo(cursol.getString(3));
	        dto.setTime(cursol.getString(4));
	        dto.setLatitude(cursol.getString(5));
	        dto.setLongitude(cursol.getString(6));
	        dto.setHelperCode(cursol.getString(7));
	        dto.setHelperName(cursol.getString(8));
	       careList.add(dto);
        }
        cursol.close();
        return careList;
    }
    public int deleteOne(String memNo,String date,String planNo){ 
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	return db.delete(DB_TABLE,where,whereArgs);
    }
    public int deleteSet(String memNo,String date){ 
    	String where="memNo=? AND date=?";
    	String[] whereArgs=new String[2];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	return db.delete(DB_TABLE,where,whereArgs);
    }    
    public int deleteAll(){    	
    	return db.delete(DB_TABLE,null,null);
    }
    public int insertOne(WalkDTO dto){
    	ContentValues values=new ContentValues();    	
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("planNo",dto.getPlanNo());
        values.put("time",dto.getTime());        
        values.put("latitude",dto.getLatitude());
        values.put("longitude",dto.getLongitude());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
        return (int)db.insert(DB_TABLE,null,values);
    }
    public int insertSet(ArrayList<WalkDTO> careList){
    	int count=0;
    	for(int i=0;i<careList.size();i++){
    		this.insertOne(careList.get(i));
    		count++;
    	}
    	return count;
    }
    //s̍XV
    public int updateOne(WalkDTO dto){
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=dto.getMemNo();
    	whereArgs[1]=dto.getDate();
    	whereArgs[2]=dto.getPlanNo();
        ContentValues values=new ContentValues();
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("planNo",dto.getPlanNo());
        values.put("time",dto.getTime());        
        values.put("latitude",dto.getLatitude());
        values.put("longitude",dto.getLongitude());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
        return db.update(DB_TABLE,values,where,whereArgs);
    }
    public int updateSet(ArrayList<WalkDTO> careList){
    	int count=0;
    	for(int i=0;i<careList.size();i++){
    		this.updateOne(careList.get(i));
    		count++;
    	}
    	return count;
    }
}
